
<h2>Rgle de calcul des feuilles de travail</h2>

!set wims_backslash_insmath=yes

!if $wims_user=supervisor
<p>
Le serveur calcule pour chaque exercice trois indicateurs du
 travail de chaque participant (l'indicateur de cumul (\(i_0)),
 l'indicateur de russite (\(i_1)) et l'indicateur d'acquisition
 \((i_2))) et une note de qualit \(q).
Pour expliquer le calcul des diffrents indicateurs, supposons que le nombre
de points requis sur un exercice est \(10n\) o \(n\) est un entier et que
l'lve a fait cet exercice \(p\) fois avec les scores \(x_1, x_2, x_3, ..., x_p\)
(nombres entre 0 et 10).
</p>
<ul><li>
L'indicateur de cumul \((i_0)) est la somme des scores plafonne  \(10 n\)
que l'on divise par \(10n\) : \(i_0=min(x_1+...+x_p, 10*n)/(10*n)).
Il est affich dans les rsultats de l'lve comme un pourcentage.
</li><li>
Notons \(y_1\geq y_2\geq ... \geq y_p\) les scores ordonns par ordre
dcroissant.

L'indicateur de russite (\(i_1)) est la moyenne des \(n\) meilleurs scores,
divis par 10 :
 \(i_1 = (y_1+...+y_n)/(n*10)) si le nombre \(p\) de scores obtenus est suprieur
   \(n\) et
 \(i_1 = (y_1+...+y_p)/(n*10)) si
le nombre \(p\) de scores obtenus est infrieur  \(n).
Il est affich ensuite comme un pourcentage.
</li><li>
L'indicateur d'acquisition (\(i_2)) est le plus petit des \(n\) meilleurs scores
divis par 10 :
\(i_2 = 0) si le nombre \(p\) de scores obtenus est infrieur  \(n\)
et \(i_2= y_n/10\) si \(p\geq n\).
</li></ul>
<p>
Par exemple, si \(n=2\) et si les scores sont 7, 5 et 3 alors \(i_0 = 0.75\) (75%),
\(i_1=0.6\) (60%) et \(i_2=0.5) (50%).
</p><p>
La note de qualit est la moyenne pondre et incrmentale des
scores (c'est--dire que le poids des derniers scores obtenus est plus important que
celui des premiers). Cet indicateur est corrig en sanctionnant les essais sans
rponse de la manire suivante :
si le nombre d'essais non termins \(s_n\), est strictement suprieur  \(5+2*s_t\),
o \(s_t\) est le nombre d'essais termins (avec une note),
la note de qualit est multiplie par \(\frac{2 s_t}{s_n-4} < 1\).
</p><p>
Pour chaque feuille, le serveur calcule ensuite
</p>
<ul><li>
la moyenne pondre (\(I_0, I_1, I_2)) sur tous
les exercices de la feuille des \(i_0, i_1, i_2) correspondants
avec comme coefficients de pondration le produit du poids de l'exercice et du nombre
de points requis ;
</li><li>
 la moyenne pondre \(Q\) des \(q\) avec comme coefficients
de pondration le produit du poids de l'exercice et de l'indicateur de cumul
de l'lve \(i_0\) pour cet exercice (ainsi, cela tient compte de la qualit
de ce qui a t fait).
</li>
</ul>
<p>
Si la note de qualit est infrieure  1 pour un exercice,
l'indicateur \(i) utilis pour le calcul de chacun des indicateurs \(I)
est mis  0 pour cet exercice ;
si la note de qualit est comprise entre 1 et 2,
l'indicateur \(i) utilis pour le calcul de chacun des indicateurs \(I)
 est divis par 2.
</p><p>
Les valeurs de \(Q, I_0, I_1, I_2\) sont donnes sur chaque feuille
dans la page de suivi individuel des tudiants.
</p><p>
Le serveur calcule alors la note de la feuille suivant une rgle de
calcul que vous dfinissez (vous pouvez choisir la rgle et l'indicateur \(I\)
utilis parmi \(I_0, I_1, I_2)).

Voici les formules possibles :
</p>

!reset table_center
$table_header
$table_hdtr<th>Rgle</th><th>Formule</th><th>$wims_name_Explanations</th></tr>
$table_tr<td>0</td><td> \($scoremax * $(list[1;]) \)
 </td><td>maximum entre l'indicateur choisi et qualit.</td></tr>
$table_tr<td>1</td><td> \($scoremax *$(list[2;]) \)
 </td><td>La qualit n'est pas prise en compte. Vous avez la note maximale
 lorsque l'indicateur choisi est maximal.</td></tr>
$table_tr<td>2</td><td>\($scoremax*$(list[3;])\)
 </td><td>La qualit n'a que peu d'effet sur la note.</td></tr>
$table_tr<td>3</td><td>\($scoremax*$(list[4;])\)
 </td><td>Plus d'effet de la qualit.</td></tr>
$table_tr<td>4</td><td>\($scoremax*$(list[5;])\)
 </td><td>Pour avoir une note de $scoremax, il faut avoir tous les points
  demands (100%) sans faire de faute (qualit=10).</td></tr>
$table_tr<td>5</td><td>$\($scoremax*$(list[6;])\)
 </td><td></td></tr>
$table_end
!read help/sheetscore.phtml
!else
Pour cette feuille, votre enseignant a choisi le mode de calcul suivant
de la note. Le nombre de points requis est \(10n\).
Pour chacun des exercices, on calcule
<ul>
<li>
!if $help_sw=0
  \(i\) : la somme des scores plafonne  \(10n\)
que l'on divise par \(10n\) (indicateur de cumul)
!endif
!if $help_sw=1
 la moyenne \(i\) des \(n\) meilleurs scores divis par 10 (niveau de russite) :
 si vos scores sont \(y_1\geq y_2\geq ... \geq y_p \) ordonns par ordre
dcroissant :
 \(i = (y_1+...+y_n)/(10n)\) si le nombre \(p\) de scores obtenus est suprieur  \(n\)
 et
 \(i = (y_1+...+y_p)/(10n)) si le nombre \(p\) de scores obtenus est infrieur  \(n\).
!endif
!if $help_sw=2
 le minimum \(i\) des \(n\) meilleures notes divis par 10 (niveau d'acquisition) :
 si vos scores sont \(y_1\geq y_2\geq ... \geq y_p \) ordonns par ordre
dcroissant :
  \(i = 0\) tant que le nombre \(p\) de scores obtenus est infrieur  \(n) et
 et ensuite
 \(i = y_n/10).
!endif
</li>
!if $help_level>0
<li>
la qualit \(q\) des points obtenus sur les exercices qui est
une moyenne pondre, les derniers scores ayant un poids plus important que
les premiers. Attention, si vous renouvelez l'exercice sans le terminer un nombre trop
important de fois par rapport au nombre de fois o vous avez termin l'exercice,
la note de qualit diminuera.
</li>
!endif
</ul>
La note de la feuille est calcule  partir des moyennes pondres
\(I) et \(Q) des \(i) et de \(q) de chaque exercice.

!if $help_level>0
Si la note de qualit est infrieure  1 pour un exercice,
l'indicateur \(i\) est mis  0 pour cet exercice ;
si la note de qualit est comprise entre 1 et 2,
l'indicateur \(i\) est divis par 2.
!else
 Cependant, si vous avez eu trop d'checs ou si vous avez
 essay trop de fois l'exercice sans le terminer, cette note peut diminuer.
 Demandez  votre enseignant.
!endif
<p>
 La note de la feuille est calcule comme
<span class="bold">$scoremax $(list[$help_level+1;])</span>.
</p>
!endif
